use strict;
use warnings;
use inc::Module::Install;

name 'CXC-ACIS-Command';
license 'gpl3';
auto_license( holder => 'Smithsonian Astrophysical Observatory' );

version 0.02;
author 'Diab Jerius <djerius@cfa.harvard.edu>';
license 'gpl3';

requires 'Astro::FITS::CFITSIO::Simple';
requires 'HTML::TableParser';
requires 'HTTP::Tiny';
requires 'IO::File';
requires 'PDL::Lite';
requires 'Path::Tiny';
requires 'Pegex::Base';
requires 'Pegex::Grammar';
requires 'Pegex::Parser';
requires 'Pegex::Tree';
requires 'Try::Tiny';
requires 'Type::Library';
requires 'Type::Params';
requires 'Type::Utils';
requires 'Types::Standard';
requires 'Types::XSD';


author_tests( 'xt' );
author_requires 'Test::NoBreakpoints';
author_requires 'Test::Pod';
author_requires 'Test::Pod::Coverage';
author_requires 'Test::Perl::Critic';

tests_recursive;

build_requires 'Test::More';
build_requires 'Test::Deep';
build_requires 'Test::Fatal';
build_requires 'YAML';
build_requires 'YAML::XS';


auto_install;

WriteAll;
