package CXC::ACIS::Command::Constants;

use strict;
use warnings;

our $VERSION = '0.02';

use Exporter qw[ import ];

our @EXPORT_OK = qw[

  %HWPulse
  %HWSerial
  %CMD
  %Mode
  %SysConfig
  %DeaQueryCntl
  %DeaQueryCcd

];


our %HWPulse = (

    0x00 => "1DEPSAEN (ENABLE DEA A)",
    0x01 => "1DEPSAOF (POWER OFF DEA A)",
    0x02 => "1DEPSADS (DISABLE DEA A)",
    0x03 => "1DEPSAON (POWER ON DEA A)",
    0x04 => "1DPPSADS (DISABLE DPA A)",
    0x05 => "1DPPSAON (POWER ON DPA A)",
    0x06 => "1DPPSAEN (ENABLE DPA A)",
    0x07 => "1DPPSAOF (POWER OFF DPA A)",
    0x08 => "1MCMDAEN (ENABLE MECHANISM A)",
    0x09 => "1MCMDADS (DISABLE MECHANISM A)",
    0x0a => "1VVCAEN  (ENABLE VENT A)",
    0x0b => "1LVCAEN  (ENABLE RELIEF A)",
    0x0c => "1MODRAON (OPEN DOOR ON A)",
    0x0d => "1MCDRAON (CLOSE DOOR ON A)",
    0x0e => "1MODRAOF (OPEN DOOR OFF A)",
    0x0f => "1MCDRAOF (CLOSE DOOR OFF A)",
    0x10 => "1VVCADS  (DISABLE VENT A)",
    0x11 => "1VVCOAON (OPEN VENT ON A)",
    0x12 => "1VVCCAON (CLOSE VENT ON A)",
    0x13 => "1VVCOAOF (OPEN VENT OFF A)",
    0x14 => "1VVCCAOF (CLOSE VENT OFF A)",
    0x15 => "1LVCADS  (DISABLE RELIEF A)",
    0x16 => "1LVCOAON (OPEN RELIEF ON A)",
    0x17 => "1LVCCAON (CLOSE RELIEF ON A)",
    0x18 => "1HHTRADS (DISABLE HOUSING HEATER A)",
    0x19 => "1HHTRAOF (POWER OFF HOUSING HEATER A)",
    0x1a => "1HHTRAON (POWER ON HOUSING HEATER A)",
    0x1b => "1HHTRAEN (ENABLE HOUSING HEATER A)",
    0x1c => "1HBOAEN  (ENABLE BAKEOUT HEATER A)",
    0x1d => "1HBOADS  (DISABLE BAKEOUT HEATER A)",
    0x1e => "1HBOAON  (POWER ON BAKEOUT HEATER A)",
    0x1f => "1HBOAOF  (POWER OFF BAKEOUT HEATER A)",
    0x20 => "1PRESAON (TURN ON PRESSURE A)",
    0x21 => "1PRESAOF (TURN OFF PRESSURE A)",

    0x40 => "1DEPSBEN (ENABLE DEA B)",
    0x62 => "1DEPSBOF (POWER OFF DEA B)",
    0x42 => "1DEPSBDS (DISABLE DEA B)",
    0x43 => "1DEPSBON (POWER ON DEA B)",
    0x44 => "1DPPSBDS (DISABLE DPA B)",
    0x45 => "1DPPSBON (POWER ON DPA B)",
    0x46 => "1DPPSBEN (ENABLE DPA B)",
    0x47 => "1DPPSBOF (POWER OFF DPA B)",
    0x48 => "1MCMDBEN (ENABLE MECHANISM B)",
    0x49 => "1MCMDBDS (DISABLE MECHANISM B)",
    0x4a => "1VVCBEN  (ENABLE VENT B)",
    0x4b => "1LVCBEN  (ENABLE RELIEF B)",
    0x4c => "1MODRBON (OPEN DOOR ON B)",
    0x4d => "1MCDRBON (CLOSE DOOR ON B)",
    0x4e => "1MODRBOF (OPEN DOOR OFF B)",
    0x4f => "1MCDRBOF (CLOSE DOOR OFF B)",
    0x50 => "1VVCBDS  (DISABLE VENT B)",
    0x51 => "1VVCOBON (OPEN VENT ON B)",
    0x52 => "1VVCCBON (CLOSE VENT ON B)",
    0x53 => "1VVCOBOF (OPEN VENT OFF B)",
    0x54 => "1VVCCBOF (CLOSE VENT OFF B)",
    0x55 => "1LVCBDS  (DISABLE RELIEF B)",
    0x56 => "1LVCOBON (OPEN RELIEF ON B)",
    0x57 => "1LVCCBON (CLOSE RELIEF ON B)",
    0x58 => "1HHTRBDS (DISABLE HOUSING HEATER B)",
    0x59 => "1HHTRBOF (POWER OFF HOUSING HEATER B)",
    0x5a => "1HHTRBON (POWER ON HOUSING HEATER B)",
    0x5b => "1HHTRBEN (ENABLE HOUSING HEATER B)",
    0x5c => "1HBOBEN  (ENABLE BAKEOUT HEATER B)",
    0x5d => "1HBOBDS  (DISABLE BAKEOUT HEATER B)",
    0x5e => "1HBOBON  (POWER ON BAKEOUT HEATER B)",
    0x5f => "1HBOBOF  (POWER OFF BAKEOUT HEATER B)",
    0x60 => "1PRESBON (TURN ON PRESSURE B)",
    0x61 => "1PRESBOF (TURN OFF PRESSURE B)",

);

our %HWSerial = (

    0x0000 => '1NOPINO     (DPA NO OP)',
    0x00c0 => '1ED0ICL  0x%02x (SET EEPROM BYTE 0)',
    0x00c1 => '1ED1ICL  0x%02x (SET EEPROM BYTE 1)',
    0x00c2 => '1ED2ICL  0x%02x (SET EEPROM BYTE 2)',
    0x00c3 => '1ED3ICL  0x%02x (SET EEPROM BYTE 3)',
    0x00f0 => '1ERBICL  0x%02x (READ EEPROM NIBBLE)',
    0x0100 => '1BSELICL 00 (BEP SELECT SIDE A)',
    0x0101 => '1BSELICL 01 (BEP SELECT SIDE B)',
    0x0200 => '1RSETIRT 00 (DPA RUN)',
    0x0201 => '1RSETIRT 01 (DPA HALT)',
    0x0300 => '1BLTSLCL 00 (SELECT SOFTWARE BILEVEL TELEMETRY)',
    0x0301 => '1BLTSLCL 01 (SELECT EEPROM DATA READOUT)',
    0x0400 => '1NOPINO     (DPA NO OP)',
    0x0500 => '1BMODIBM 00 (DPA FS BOOT MODIFIER OFF)',
    0x0501 => '1BMODIBM 01 (DPA FS BOOT MODIFIER ON)',
    0x0600 => '1WRMBTSB 00 (DPA WARM BOOT OFF)',
    0x0601 => '1WRMBTSB 01 (DPA WARM BOOT ON)',
    0x0700 => '1RMONIRM 00 (DPA RADIATION MONITOR LOW)',
    0x0701 => '1RMONIRM 01 (DPA RADIATION MONITOR HIGH)',
    0xd000 => '1EWADDCL    (WRITE EEPROM ADDRESS)',
    0xd100 => '1EWDATCL    (WRITE EEPROM DATA)',

);


our %CMD;
sub {

    while ( my ( $op, $tag, $name ) = splice( @_, 0, 3 ) ) {

        $CMD{$op} = $CMD{$name} = { tag => $tag, name => $name, op => $op };
    }
  }
  ->(


    # 0x00 => 'CMDOP_UNUSED'           => '',
    0x00 => 'CMDOP_FIFOFLUSH'        => 'fifoFlush',

    0x01 => 'CMDOP_START_UPLOAD'     => 'startUpload',
    0x02 => 'CMDOP_CONTINUE_UPLOAD'  => 'continueUpload',
    0x03 => 'CMDOP_READ_BEP'         => 'readBep',
    0x04 => 'CMDOP_READ_FEP'         => 'readFep',
    0x05 => 'CMDOP_WRITE_FEP'        => 'writeFep',
    0x06 => 'CMDOP_EXEC_FEP'         => 'executeFep',
    0x07 => 'CMDOP_READ_PRAM'        => 'readPram',
    0x08 => 'CMDOP_READ_SRAM'        => 'readSram',
    0x09 => 'CMDOP_LOAD_TE'          => 'loadTeBlock',
    0x0a => 'CMDOP_LOAD_CC'          => 'loadCcBlock',
    0x0b => 'CMDOP_LOAD_2D'          => 'load2dBlock',
    0x0c => 'CMDOP_LOAD_1D'          => 'load1dBlock',
    0x0d => 'CMDOP_LOAD_DEA'         => 'loadDeaBlock',
    0x0e => 'CMDOP_START_TE'         => 'startScience',
    0x0f => 'CMDOP_BIAS_TE'          => 'startScience',
    0x10 => 'CMDOP_START_CC'         => 'startScience',
    0x11 => 'CMDOP_BIAS_CC'          => 'startScience',
    0x12 => 'CMDOP_START_DEA'        => 'startDea',
    0x13 => 'CMDOP_STOP_SCIENCE'     => 'stopScience',
    0x14 => 'CMDOP_STOP_DEA'         => 'stopDea',
    0x15 => 'CMDOP_ADD_PATCH'        => 'addPatch',
    0x16 => 'CMDOP_REMOVE_PATCH'     => 'removePatches',
    0x17 => 'CMDOP_ADD_BAD_PIXEL'    => 'addBadPixel',
    0x18 => 'CMDOP_RESET_BAD_PIXEL'  => 'resetBadPixelMap',
    0x19 => 'CMDOP_DUMP_BAD_PIXELS'  => 'dumpBadPixels',
    0x1a => 'CMDOP_ADD_BAD_TE_COL'   => 'addBadColumn',
    0x1b => 'CMDOP_RESET_BAD_TE_COL' => 'resetBadColumnMap',
    0x1c => 'CMDOP_DUMP_BAD_TE_COL'  => 'dumpBadTeCol',
    0x1d => 'CMDOP_ADD_BAD_CC_COL'   => 'addBadColumn',
    0x1e => 'CMDOP_RESET_BAD_CC_COL' => 'resetBadColumnMap',
    0x1f => 'CMDOP_DUMP_BAD_CC_COL'  => 'dumpBadCcCol',
    0x20 => 'CMDOP_CHANGE_SYS_ENTRY' => 'changeConfigSetting',
    0x21 => 'CMDOP_DUMP_SYS_CONFIG'  => 'dumpSysConfig',
    0x22 => 'CMDOP_DUMP_PATCHLIST'   => 'dumpPatchList',
    0x23 => 'CMDOP_DUMP_HUFFMAN'     => 'dumpHuffman',
    0x24 => 'CMDOP_DUMP_TE_SLOTS'    => 'dumpTeSlots',
    0x25 => 'CMDOP_DUMP_CC_SLOTS'    => 'dumpCcSlots',
    0x26 => 'CMDOP_DUMP_2D_SLOTS'    => 'dump2dSlots',
    0x27 => 'CMDOP_DUMP_1D_SLOTS'    => 'dump1dSlots',
    0x28 => 'CMDOP_DUMP_DEA_SLOTS'   => 'dumpDeaSlots',

    0xc0 => 'CMDOP_WRITE_BEP'        => 'writeBep',
    0xc3 => 'CMDOP_EXEC_BEP'         => 'executeBep',
    0xcc => 'CMDOP_WRITE_PRAM'       => 'writePram',
    0xf0 => 'CMDOP_WRITE_SRAM'       => 'writeSram',

  );



our %Mode = (

    Fep => {

        Te => {

            0x00 => 'FEP_TE_MODE_RAW',
            0x01 => 'FEP_TE_MODE_HIST',
            0x02 => 'FEP_TE_MODE_EV3x3',
            0x03 => 'FEP_TE_MODE_EV5x5',
            0x04 => 'FEP_TE_MODE_CTI1',
            0x05 => 'FEP_TE_MODE_CTI2',
        },

        CC => {
            0x00 => 'FEP_CC_MODE_RAW',
            0x01 => 'FEP_CC_MODE_EV1x3',
            0x02 => 'FEP_CC_MODE_EV3x3',
        },

    },

    Bep => {

        Te => {
            0x00 => 'BEP_TE_MODE_FAINT',
            0x01 => 'BEP_TE_MODE_FAINTBIAS',
            0x02 => 'BEP_TE_MODE_GRADED',
            0x03 => 'BEP_TE_MODE_EVHIST'
        },

        CC => {
            0x00 => 'BEP_CC_MODE_FAINT',
            0x01 => 'BEP_CC_MODE_GRADED'
          }

    },

    Quad => {
        0x00 => 'QUAD_FULL',
        0x01 => 'QUAD_DIAG',
        0x02 => 'QUAD_AC',
        0x03 => 'QUAD_BD'
      }

);




our %SysConfig = (
    0x00 => 'SETTING_DEA_POWER',
    0x01 => 'SETTING_FEP_POWER',
    0x02 => 'SYSSET_CNTL_MASTER_CLK',
    0x03 => 'SYSSET_CNTL_FOCAL_TEMP',
    0x04 => 'SYSSET_CNTL_BAKE_TEMP',
    0x05 => 'SYSSET_CNTL_BAKE_ENABLE',
    0x06 => 'SYSSET_CNTL_LED_ENABLE',
    0x07 => 'SYSSET_CNTL_HOUSE_HOLD',
    0x08 => 'SYSSET_CNTL_SIGNAL_PATH',
    0x09 => 'SYSSET_CNTL_CMDCLOCK_DISABLE',
    0x0a => 'SYSSET_CNTL_CMDDATA_DISABLE',
    0x0b => 'SYSSET_CNTL_RELAY_SET_0',
    0x0c => 'SYSSET_CNTL_RELAY_SET_1',
    0x0d => 'SYSSET_CNTL_RELAY_SET_2',
    0x0e => 'SYSSET_CNTL_RELAY_SET_3',
    0x0f => 'SYSSET_CNTL_RELAY_SET_4',
    0x10 => 'SYSSET_CCD_SEQ_OFFSET',
    0x11 => 'SYSSET_CCD_ADC_OFFSET',
    0x12 => 'SYSSET_CCD_VIDEO_DISABLE',
    0x13 => 'SYSSET_CCD_HOLD_HOUSE',
    0x14 => 'SYSSET_CCD_BJD',
    0x15 => 'SYSSET_CCD_HIGH_SPEED_TAP',
    0x16 => 'SYSSET_DAC_PIA_P',
    0x17 => 'SYSSET_DAC_PIA_MP',
    0x18 => 'SYSSET_DAC_PIA_M',
    0x19 => 'SYSSET_DAC_PFS_P',
    0x1a => 'SYSSET_DAC_PFS_MP',
    0x1b => 'SYSSET_DAC_PFS_M',
    0x1c => 'SYSSET_DAC_S_P',
    0x1d => 'SYSSET_DAC_S_M',
    0x1e => 'SYSSET_DAC_R_P',
    0x1f => 'SYSSET_DAC_R_MP',
    0x20 => 'SYSSET_DAC_R_M',
    0x21 => 'SYSSET_DAC_SCP',
    0x22 => 'SYSSET_DAC_OG_P',
    0x23 => 'SYSSET_DAC_OG_M',
    0x24 => 'SYSSET_DAC_RD',
    0x25 => 'SYSSET_DAC_DR0',
    0x26 => 'SYSSET_DAC_DR1',
    0x27 => 'SYSSET_DAC_DR2',
    0x28 => 'SYSSET_DAC_DR3',
    0x29 => 'SYSSET_DAC_A_OFF',
    0x2a => 'SYSSET_DAC_B_OFF',
    0x2b => 'SYSSET_DAC_C_OFF',
    0x2c => 'SYSSET_DAC_D_OFF',
    0x2d => 'SYSSET_DAC_SPARE'
);

our %DeaQueryCntl = (
    0x00 => 'DEAHOUSE_CNTL_RELAY',
    0x01 => 'DEAHOUSE_CNTL_ADC_TMP_BEP_PCB',
    0x02 => 'DEAHOUSE_CNTL_ADC_TMP_BEP_OSC',
    0x03 => 'DEAHOUSE_CNTL_ADC_TMP_FEP0_MONG',
    0x04 => 'DEAHOUSE_CNTL_ADC_TMP_FEP0_PCB',
    0x05 => 'DEAHOUSE_CNTL_ADC_TMP_FEP0_ACTEL',
    0x06 => 'DEAHOUSE_CNTL_ADC_TMP_FEP0_RAM',
    0x07 => 'DEAHOUSE_CNTL_ADC_TMP_FEP0_FB',
    0x08 => 'DEAHOUSE_CNTL_ADC_TMP_FEP1_MONG',
    0x09 => 'DEAHOUSE_CNTL_ADC_TMP_FEP1_PCB',
    0x0a => 'DEAHOUSE_CNTL_ADC_TMP_FEP1_ACTEL',
    0x0b => 'DEAHOUSE_CNTL_ADC_TMP_FEP1_RAM',
    0x0c => 'DEAHOUSE_CNTL_ADC_TMP_FEP1_FB',
    0x0d => 'DEAHOUSE_CNTL_ADC_SUBAHK',
    0x0e => 'DEAHOUSE_CNTL_ADC_SPARE1',
    0x0f => 'DEAHOUSE_CNTL_ADC_FPTEMP_12',
    0x10 => 'DEAHOUSE_CNTL_ADC_FPTEMP_11',
    0x11 => 'DEAHOUSE_CNTL_ADC_DPAGNDREF1',
    0x12 => 'DEAHOUSE_CNTL_ADC_DPA5VHKA',
    0x13 => 'DEAHOUSE_CNTL_ADC_DPAGNDREF2',
    0x14 => 'DEAHOUSE_CNTL_ADC_DPA5VHKB',
    0x15 => 'DEAHOUSE_CNTL_ADC_UNUSED1',
    0x16 => 'DEAHOUSE_CNTL_ADC_UNUSED2',
    0x17 => 'DEAHOUSE_CNTL_ADC_UNUSED3',
    0x18 => 'DEAHOUSE_CNTL_ADC_UNUSED4',
    0x19 => 'DEAHOUSE_CNTL_ADC_DEA28VDCA',
    0x1a => 'DEAHOUSE_CNTL_ADC_DEA24VDCA',
    0x1b => 'DEAHOUSE_CNTL_ADC_DEAM15VDCA',
    0x1c => 'DEAHOUSE_CNTL_ADC_DEAP15VDCA',
    0x1d => 'DEAHOUSE_CNTL_ADC_DEAM6VDCA',
    0x1e => 'DEAHOUSE_CNTL_ADC_DEAP6VDCA',
    0x1f => 'DEAHOUSE_CNTL_ADC_RAD_PCB_A',
    0x20 => 'DEAHOUSE_CNTL_ADC_GND_1',
    0x21 => 'DEAHOUSE_CNTL_ADC_DEA28VDCB',
    0x22 => 'DEAHOUSE_CNTL_ADC_DEA24VDCB',
    0x23 => 'DEAHOUSE_CNTL_ADC_DEAM15VDCB',
    0x24 => 'DEAHOUSE_CNTL_ADC_DEAP15VDCB',
    0x25 => 'DEAHOUSE_CNTL_ADC_DEAM6VDCB',
    0x26 => 'DEAHOUSE_CNTL_ADC_DEAP6VDCB',
    0x27 => 'DEAHOUSE_CNTL_ADC_RAD_PCB_B',
    0x28 => 'DEAHOUSE_CNTL_ADC_GND_2',
);

our %DeaQueryCcd = (

    0x00 => 'DEAHOUSE_CCD_REG_0',
    0x01 => 'DEAHOUSE_CCD_REG_1',
    0x02 => 'DEAHOUSE_CCD_REG_2',
    0x03 => 'DEAHOUSE_CCD_REG_3',

    0x80 => 'DEAHOUSE_CCD_PIA_P',
    0x81 => 'DEAHOUSE_CCD_PIA_M',
    0x82 => 'DEAHOUSE_CCD_PFS_P',
    0x83 => 'DEAHOUSE_CCD_PFS_M',
    0x84 => 'DEAHOUSE_CCD_S_P',
    0x85 => 'DEAHOUSE_CCD_S_M',
    0x86 => 'DEAHOUSE_CCD_R_P',
    0x87 => 'DEAHOUSE_CCD_R_M',
    0x88 => 'DEAHOUSE_CCD_OG',
    0x89 => 'DEAHOUSE_CCD_SCP',
    0x8a => 'DEAHOUSE_CCD_RD',
    0x8b => 'DEAHOUSE_CCD_DR0',
    0x8c => 'DEAHOUSE_CCD_DR1',
    0x8d => 'DEAHOUSE_CCD_DR2',
    0x8e => 'DEAHOUSE_CCD_DR3',
    0x8f => 'DEAHOUSE_SPARE',
    0x90 => 'DEAHOUSE_CCD_TEMP_BOARD',
    0x91 => 'DEAHOUSE_CCD_TEMP_SRAM',
    0x92 => 'DEAHOUSE_CCD_TEMP_ADC',
    0x93 => 'DEAHOUSE_CCD_TEMP_ACTEL'

);

1;

