package CXC::ACIS::Command::Dump::Grammar;

use strict;
use warnings;

our $VERSION = '0.02';

use Pegex::Base;
extends 'Pegex::Grammar';

has text => (
	     default => sub { q{
%grammar acis-dot
%version 0.0.1


command_stream: command_blocks
     doc_ending

command_block: ~ name
       <LSQUARE> idx <RSQUARE>
       ~ <EQUAL> ~ <LCURLY>
       ~ elements
       ~ <RCURLY>
       <EOL>

element_block: ~ name
       <LSQUARE> idx <RSQUARE>
       ~ <EQUAL> ~ <LCURLY>
       ~ elements
       ~ <RCURLY>
       <EOL>

doc_ending : / ~ <EOS> /

command_blocks : command_block+ % ~

element_blocks : element_block+ % ~

elements : ( element_blocks | attribute )* % ~

attribute: name  ~  <EQUAL> ~ value ~ ( comment? | <EOL> )

name: /( <WORD>+ )/
idx: integer

comment: / <HASH> <ANY>* <EOL> /

value: scalar* % ~

scalar: integer

integer: hexint | decint

decint: /(0 | [1-9] <DIGIT>*)/

hexint: /( 0 [xX] <HEX>+ ) /

}} );

1;
