package CXC::ACIS::Command::Types;

use strict;
use warnings;

our $VERSION = '0.02';

use Type::Library
  -base,
  -declare => qw[
  CcdId
  CcdColumn
  CcdRow
  ColumnCount
  FepEventThreshold
  FepSplitThreshold
  FepId
  FepCcdSelect
  GradeSelection
  GradeSelections
  RowCount
];

use Types::Standard -types;
use Type::Utils -all;
use Types::XSD qw[ NonNegativeInteger
		   PositiveInteger
		   Short
		   UnsignedShort
		];

declare CcdId,
as NonNegativeInteger [ maxInclusive => 9 ];

declare CcdColumn,
as NonNegativeInteger [ maxInclusive => 1023 ];

declare CcdRow,
as NonNegativeInteger [ maxInclusive => 1023 ];

declare RowCount,
as PositiveInteger [ maxInclusive => 1024 ];

declare ColumnCount,
as PositiveInteger [ maxInclusive => 1024 ];

declare FepId,
as NonNegativeInteger [ maxInclusive => 5 ];

declare FepCcdSelect,
as ArrayRef [ CcdId | enum [10] ];

declare FepEventThreshold,
as Tuple [ (Short) x 4 ];

declare FepSplitThreshold,
as Tuple [ (UnsignedShort) x 4 ];

declare GradeSelection,
as NonNegativeInteger;

declare GradeSelections,
as Tuple [ (GradeSelection) x 8 ];


1;



